/*  SpiralPlugin
 *  Copyleft (C) 2000 David Griffiths <dave@pawfal.org>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/ 

#include "MidiPluginGUI.h"
#include <FL/fl_draw.h>
#include <FL/fl_file_chooser.H>

static const int GUI_COLOUR = 154;
static const int GUIBG_COLOUR = 144;
static const int GUIBG2_COLOUR = 145;

MidiPluginGUI::MidiPluginGUI(int w, int h,MidiPlugin *o,const HostInfo *Info) :
SpiralPluginGUI(w,h,o)
{	
	m_Plugin=o;
	
	m_DeviceNum = new Fl_Counter(20,30,40,20,"Device");
	m_DeviceNum->type(FL_SIMPLE_COUNTER);
	m_DeviceNum->step(1);
	m_DeviceNum->callback((Fl_Callback*)cb_DeviceNum, NULL);
	
	m_NoteCut = new Fl_Button(8,70,65,20,"Note Cut");
	m_NoteCut->type(1);
	m_NoteCut->callback((Fl_Callback*)cb_NoteCut, NULL);
}

void MidiPluginGUI::UpdateValues()
{
	m_DeviceNum->value(m_Plugin->GetDeviceNum());
}
	
//// Callbacks ////
inline void MidiPluginGUI::cb_DeviceNum_i(Fl_Counter* o, void* v) 
{ m_Plugin->SetDeviceNum(o->value()); }
void MidiPluginGUI::cb_DeviceNum(Fl_Counter* o, void* v) 
{ ((MidiPluginGUI*)(o->parent()))->cb_DeviceNum_i(o,v);}

inline void MidiPluginGUI::cb_NoteCut_i(Fl_Button* o, void* v) 
{ m_Plugin->SetNoteCut(o->value()); }
void MidiPluginGUI::cb_NoteCut(Fl_Button* o, void* v) 
{ ((MidiPluginGUI*)(o->parent()))->cb_NoteCut_i(o,v);}
