/*  SpiralSound
 *  Copyleft (C) 2001 David Griffiths <dave@pawfal.org>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/ 

#include "SpiralPlugin.h"

SpiralPlugin::SpiralPlugin():
m_GUI(NULL)
{
	m_Version=1;
	m_ValuesChanged=true;
	m_PluginInfo.Name="BasePlugin";
	m_PluginInfo.Width=100;
	m_PluginInfo.Height=100;
	m_PluginInfo.NumInputs=0;
	m_PluginInfo.NumOutputs=0;
	UpdateInfo=NULL;
}

SpiralPlugin::~SpiralPlugin()
{
	for (int n=0; n<m_PluginInfo.NumOutputs; n++)
	{
		delete m_Output[n];
	}	
	
	if (m_GUI) 
	{
		m_GUI->hide();
		delete m_GUI;
	}
}

PluginInfo &SpiralPlugin::Initialise(const HostInfo *Host)
{	
	m_HostInfo=Host;

	for (int n=0; n<m_PluginInfo.NumInputs; n++)
	{
		m_Input.push_back(NULL);
	}
	
	for (int n=0; n<m_PluginInfo.NumOutputs; n++)
	{
		m_Output.push_back(NULL);
	}
	
	return m_PluginInfo;
}

bool SpiralPlugin::GetOutput(unsigned int n, Sample **s)
{
	if (n>=m_Output.size()) return false;
	*s = m_Output[n];
	
	return true;
}

bool SpiralPlugin::SetInput(unsigned int n, const Sample *s)
{
	if (n>=m_Input.size()) return false;
	m_Input[n]=s;
	return true;
}
	
bool SpiralPlugin::ValueChanged()          
{ 
	if (m_ValuesChanged) 
	{ 
		m_ValuesChanged=false; 
		return true; 
	}	
	return false;
}
